#include <bits/stdc++.h>
#include <grpcpp/grpcpp.h>
#include "keyvaluestore.grpc.pb.h"

using namespace std;

using grpc::Server;
using grpc::ServerAsyncResponseWriter;
using grpc::ServerBuilder;
using grpc::ServerCompletionQueue;
using grpc::ServerContext;
using grpc::Status;
using keyvaluestore::KeyValueServices;
using keyvaluestore::Info;
using keyvaluestore::Null;

ServerBuilder builder;
KeyValueServices::AsyncService service;
std::unique_ptr<Server> server;

class DNSData {
public:
    DNSData(KeyValueServices::AsyncService *service, ServerCompletionQueue *cq) : service(service), cq(cq), getAddressResponder(&context), status(CREATE) {
        Proceed();
    }

    void Proceed() {
        if (status == CREATE) {
            status = PROCESS;
            service->RequestGETADDRESS(&context, &null, &getAddressResponder, cq, cq, this);
        }
        else if (status == PROCESS) {
            new DNSData(service, cq);
            status = FINISH;
        }
        else {
            GPR_ASSERT(status == FINISH);
            delete this;
        }
    }

private:
    KeyValueServices::AsyncService *service;
    ServerCompletionQueue *cq;
    ServerContext context;
    Null null;
    Info info;
    ServerAsyncResponseWriter<Info> getAddressResponder;
    enum CallStatus {
        CREATE,
        PROCESS,
        FINISH
    };
    CallStatus status;
};

int main(int argc,char **argv) {
    string server_address("0.0.0.0:1234");
    builder.AddListeningPort(server_address, grpc::InsecureServerCredentials());
    builder.RegisterService(&service);
    unique_ptr<ServerCompletionQueue> comp_queue=builder.AddCompletionQueue();
    server = builder.BuildAndStart();
    new DNSData(&service,comp_queue.get());
    void *tag;
    bool ok;
    while(true) {
        GPR_ASSERT(comp_queue->Next(&tag,&ok));
        GPR_ASSERT(ok);
        static_cast<DNSData *>(tag)->Proceed();
    }
}